//+------------------------------------------------------------------+
//|                                          band_martingaile.mq4    |
//|                                                                  |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007"
#property link      "mailto:tradertobe@gmail.com"
#include <stderror.mqh>
#include <stdlib.mqh>
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
//      -,     - ,      
//      ...
//     1000 . 4  5   ,    ... 
extern int  MagicNumberSell      = 999;        // 
extern int  MagicNumberBuy       = 888;        //  
extern bool NewTradeCycleAllowed = true;       //         
extern int  Band = 20;                         //    ....
extern int  TradeCycleDirection  = -1;         // -1 - sell, +1 - buy

extern double ProfitCloseValue = 4;     //     ,    
extern bool   TradeCycleClose  = false; //        ProfitCloseValue,    
extern double LotStep          = 0.01;  //      
extern int    TakeProfit       = 1000;
extern int    StopLoss         = 0;


int _ExpertOrdersTotal;    //  ,  
int _ExpertOrdersBuy;     
int _ExpertOrdersSell;     
int _ExpertOrdersBuyStop;    
int _ExpertOrdersSellStop;     
int _ExpertOrdersBuyLimit;    
int _ExpertOrdersSellLimit;     

// ,           :
int      _OrderTicket[], _OrderType[];
double   _OrderLots[], _OrderOpenPrice[], _OrderStopLoss[], _OrderTakeProfit[];
double   _OrderProfit[], _OrderSwap[], _OrderCommission[];
datetime _OrderOpenTime[], _OrderExpiration[];
string   _OrderComment[];
int      _OrderMagicNumber[];

color   Order_Clr;
#define ORDER_BUY_CLR  Blue 
#define ORDER_SELL_CLR Red

string OrderOpenSetOkMes       = "  - / "; 
string OrderOpenSetErrorMes    = "  -  /";  

string OrderModifyOkMes        = "  -  ";   
string OrderModifyErrorMes     = "  -   "; 

string OrderDeleteOkMes        = "  -  "; 
string OrderDeleteErrorMes     = "  -   "; 

string OrderCloseOkMes        = "  -  "; 
string OrderCloseErrorMes     = "  -   "; 


int LastError;
int i;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
    if (Digits == 5 ||Digits == 3 ) 
    {
     Band *= 10;                         
     TakeProfit *=10;      
     StopLoss  *=10;       
    }
//----
    return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   TradeCycleDirection = -1;
   AllOrdersInit(MagicNumberSell);
   if (OrdersOpenSet()) return(0); 
   
   AllOrdersInit(MagicNumberSell);
   if (OrdersClose()  ) return(0);  
   
   AllOrdersInit(MagicNumberSell);
   if (OrdersDelete() ) return(0);   
   

   
//----
/*
   TradeCycleDirection = +1;
   AllOrdersInit(MagicNumberBuy);
   if (OrdersOpenSet()) return(0); 
   if (OrdersClose()  ) return(0);   
   if (OrdersDelete() ) return(0);   
//----
*/
   return(0); //   
  }
//+---------------------------------------------------------------------------------------------------------------+
//|                    |
//+---------------------------------------------------------------------------------------------------------------+
bool OrdersOpenSet()   // return(true) -         
   {                   // return(false)-     ,        start()
//----
    if (_ExpertOrdersTotal == 0 && NewTradeCycleAllowed && !TradeCycleClose)  
     {
      i = _ExpertOrdersTotal; //  
      _OrderType       [i] = iif(TradeCycleDirection < 0,OP_SELL,OP_BUY);
      _OrderLots       [i] = LotStep;
      _OrderOpenPrice  [i] = iif(_OrderType[i]==OP_BUY,Ask,Bid);

      _OrderStopLoss  [i] = iif(_OrderType[i]==OP_BUY,_OrderOpenPrice[i] - StopLoss * Point,_OrderOpenPrice[i] + StopLoss * Point);
      _OrderStopLoss  [i] = iif( _OrderStopLoss[i]==_OrderOpenPrice[i],0,_OrderStopLoss[i]);

      _OrderTakeProfit[i] = iif(_OrderType[i]==OP_BUY,_OrderOpenPrice[i] + TakeProfit*Point,_OrderOpenPrice[i] - TakeProfit*Point);
      _OrderTakeProfit[i] = iif(_OrderTakeProfit[i] == _OrderOpenPrice[i],0,_OrderTakeProfit[i]);

      _OrderMagicNumber[i] = iif(TradeCycleDirection > 0,MagicNumberBuy,MagicNumberSell);
      _OrderComment    [i] = " "; 
      Order_Clr            = iif(TradeCycleDirection > 0,ORDER_BUY_CLR,ORDER_SELL_CLR);  
      _OrderSend();
      return(true);
     }
 //----
    if ( _ExpertOrdersTotal != 0 && _ExpertOrdersBuyStop == 0 && _ExpertOrdersSellStop == 0 && !TradeCycleClose)
     {     
      double LotsTotalBuy  = 0;
      double LotsTotalSell = 0; 
      double OrderOpenPriceBuy  = 0;
      double OrderOpenPriceSell = 0;
      for (i = 0; i < _ExpertOrdersTotal; i++)
      {
 	    switch(_OrderType [i])
       {
        case OP_BUY  : LotsTotalBuy  += _OrderLots[i]; OrderOpenPriceBuy  = _OrderOpenPrice [i]; break; 
        case OP_SELL : LotsTotalSell += _OrderLots[i]; OrderOpenPriceSell = _OrderOpenPrice [i]; break;
       }
      }     
      OrderOpenPriceBuy  = iif(OrderOpenPriceBuy  == 0,OrderOpenPriceSell + Band*Point,OrderOpenPriceBuy); 
      OrderOpenPriceSell = iif(OrderOpenPriceSell == 0,OrderOpenPriceBuy  - Band*Point,OrderOpenPriceSell);                                 
                                      
      i = _ExpertOrdersTotal; //            
      _OrderType      [i] = iif(LotsTotalBuy < LotsTotalSell,OP_BUYSTOP,OP_SELLSTOP);
      _OrderLots      [i] = iif(LotsTotalBuy < LotsTotalSell,LotsTotalSell-LotsTotalBuy+LotsTotalSell,LotsTotalBuy-LotsTotalSell+LotsTotalBuy);
      _OrderOpenPrice [i] = iif(LotsTotalBuy < LotsTotalSell,OrderOpenPriceBuy,OrderOpenPriceSell);
      
      _OrderStopLoss  [i] = iif(_OrderType[i]==OP_BUYSTOP,_OrderOpenPrice[i] - StopLoss * Point,_OrderOpenPrice[i] + StopLoss * Point);
      _OrderStopLoss  [i] = iif( _OrderStopLoss[i]==_OrderOpenPrice[i],0,_OrderStopLoss[i]);
      
      _OrderTakeProfit[i] = iif(_OrderType[i]==OP_BUYSTOP,_OrderOpenPrice[i] + TakeProfit*Point,_OrderOpenPrice[i] - TakeProfit*Point);
      _OrderTakeProfit[i] = iif(_OrderTakeProfit[i] == _OrderOpenPrice[i],0,_OrderTakeProfit[i]);
      
      _OrderMagicNumber[i] = iif(TradeCycleDirection > 0,MagicNumberBuy,MagicNumberSell);
      _OrderComment    [i] = " "; 
      Order_Clr           = iif(TradeCycleDirection > 0,ORDER_BUY_CLR,ORDER_SELL_CLR);  
      _OrderSend(); 
       return(true);
     }
//----
    return(false); //     ,        start()
   }
//+------------------------------------------------------------------+
//|               |
//|                       |
//+------------------------------------------------------------------+
bool _OrderSend()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   _OrderTicket[i]=  
        OrderSend(Symbol(),_OrderType       [i]
                          ,_OrderLots       [i]
                          ,_OrderOpenPrice  [i] ,3
                          ,_OrderStopLoss   [i]
                          ,_OrderTakeProfit [i]
                          ,_OrderComment    [i]
                          ,_OrderMagicNumber[i],0,Order_Clr);
   if (_OrderTicket[i] < 0)
    {
     LastError = GetLastError();
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+OrderOpenSetErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
    }
   Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderOpenSetOkMes);
   PlaySound("ok.wav");
   return(true);
}           
//+---------------------------------------------------------------------------------------+
//|           |
//+---------------------------------------------------------------------------------------+
/*
bool OrdersModify()    // return(true) -         
   {                   // return(false)-     ,        start()
//----
    if (_ExpertOrdersTotal == 0) return(false);
    if (_ExpertOrdersOpen  == 0) return(false);
    if (_ExpertOrdersOpen  == 1) return(false);
    if (_ExpertOrdersLimit  < 2) return(false);
    
    for (i = 0; i <= _ExpertOrdersTotal-2; i++) //       (   )  
     {
      if (_OrderStopLoss[i] == _OrderStopLoss[_ExpertOrdersTotal-1]) continue; //  
      _OrderStopLoss  [i] = _OrderStopLoss[_ExpertOrdersTotal-1]; 
      _OrderTakeProfit[i] = iif(i <=_ExpertOrdersTotal-4,_OrderOpenPrice[_ExpertOrdersTotal-4],_OrderTakeProfit[i]);
      _OrderModify();
      return(true); 
     }
 //----
   return(false); //     ,        start()
   }
//+--------------------------------------------------------------------+
//|                 |
//|                              |
//+--------------------------------------------------------------------+
bool _OrderModify()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderModify(_OrderTicket    [i]
                  ,_OrderOpenPrice [i]
                  ,_OrderStopLoss  [i]
                  ,_OrderTakeProfit[i]
                  ,0
                  ,CLR_NONE))
    {
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError(); if (LastError == ERR_NO_RESULT) return(true);
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }   
*/          
//+---------------------------------------------------------------------------------------+
//|     ,        |
//+---------------------------------------------------------------------------------------+
bool OrdersDelete()    // return(true) -         
{                   // return(false)-     ,        start()
//----
    if (TradeCycleClose)
    {
     if ( (_ExpertOrdersSell + _ExpertOrdersBuy) != 0)  return(false);
     if (_ExpertOrdersTotal == 0) { TradeCycleClose = false; return(false); }
     
     for (i = 0; i < _ExpertOrdersTotal; i++)  
     {
 	   switch(_OrderType [i])
      {
       case OP_BUYSTOP  : _OrderDelete();   break; 
       case OP_SELLSTOP : _OrderDelete();   break;
      }
     }     
    }
  //----
    return(true);  
}
//+--------------------------------------------------------------------+
//|                 |
//|                                             |
//+--------------------------------------------------------------------+
bool _OrderDelete()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderDelete(_OrderTicket[i]
                   ,CLR_NONE))
    {
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderDeleteOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError();  
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderDeleteErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }  
//+----------------------------------------------------------------------------------------------------------------------+
//|      ,           |
//+----------------------------------------------------------------------------------------------------------------------+
bool OrdersClose()   // return(true) -         
{                  // return(false)-     ,        start()
//----
    double TotalProfit = 0;
    for (i = 0; i < _ExpertOrdersTotal; i++)  
    {
 	  switch(_OrderType [i])
     {
      case OP_BUY  : TotalProfit  += _OrderProfit[i];   break; 
      case OP_SELL : TotalProfit  += _OrderProfit[i];   break;
     }
    }     
    if (TotalProfit >  ProfitCloseValue) TradeCycleClose = true;
    if (TradeCycleClose)
    {
     for (i = 0; i < _ExpertOrdersTotal; i++)  
     {
 	   switch(_OrderType [i])
      {
       case OP_BUY  : _OrderClose();   break; 
       case OP_SELL : _OrderClose();   break;
      }
     }     
    }
//----  
    return(false);   
}
 //+--------------------------------------------------------------------+
//|                 |
//|                                             |
//+--------------------------------------------------------------------+
bool _OrderClose()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   _OrderOpenPrice[i] = iif(_OrderType[i] == OP_BUY,Bid,Ask);          // _OrderOpenPrice[i] -         
   if (OrderClose(_OrderTicket   [i]
                 ,_OrderLots     [i]
                 ,_OrderOpenPrice[i],3
                 ,CLR_NONE))
    {
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderCloseOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError();  
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderCloseErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }  
//+-----------------------------------------------------------------------------------------------------+
//|     ,                           |
//|  ,  .  ,                     |
//|     .             |
//|   =  _ExpertOrdersTotal + 1                                                      |
//|           /|
//|                                                                                         |
 //+----------------------------------------------------------------------------------------------------+
//"mailto:komposterius@mail.ru" -   -   
//http://www.mql4.com/ru/users/komposter  
void AllOrdersInit( int magic )
{
	int _GetLastError = 0, _OrdersTotal = OrdersTotal();
    _ExpertOrdersTotal     = 0;    //  ,  
    _ExpertOrdersBuy       = 0;    // 
    _ExpertOrdersSell      = 0;    // 
    _ExpertOrdersBuyStop   = 0;    // 
    _ExpertOrdersSellStop  = 0;    // 
    _ExpertOrdersBuyLimit  = 0;    // 
    _ExpertOrdersSellLimit = 0;    // 
 	//      - 
	// ( _OrdersTotal = 0,     1) 
	int temp_value = MathMax( _OrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );
	ArrayResize( _OrderMagicNumber,	temp_value );
	

	//  
	ArrayInitialize( _OrderTicket,		0 );    
	ArrayInitialize( _OrderType,			0 );
	ArrayInitialize( _OrderLots,			0 );
	ArrayInitialize( _OrderOpenPrice,	0 );
	ArrayInitialize( _OrderStopLoss,		0 );
	ArrayInitialize( _OrderTakeProfit,	0 );
	ArrayInitialize( _OrderOpenTime,		0 );
	ArrayInitialize( _OrderProfit,		0 );
	ArrayInitialize( _OrderSwap,			0 );
	ArrayInitialize( _OrderCommission,	0 );
	ArrayInitialize( _OrderExpiration,	0 );
	ArrayInitialize( _OrderMagicNumber,	0 );
   
 	for ( int z = 0;  z < _OrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( z, SELECT_BY_POS ) )
		{
			_GetLastError = GetLastError();
			Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #", _GetLastError );
			continue;
		}
		if (OrderMagicNumber() == magic && OrderSymbol() == Symbol() )
		{
			//    ,  
			_OrderTicket [_ExpertOrdersTotal] = OrderTicket();
 			_ExpertOrdersTotal ++;
 	   	switch(OrderType())
           {
            case OP_BUY       : _ExpertOrdersBuy++ ;        break; 
            case OP_SELL      : _ExpertOrdersSell++ ;       break;
            case OP_BUYSTOP   : _ExpertOrdersBuyStop++ ;    break;
            case OP_SELLSTOP  : _ExpertOrdersSellStop++ ;   break;
            case OP_BUYLIMIT  : _ExpertOrdersBuyLimit++ ;   break;
            case OP_SELLLIMIT : _ExpertOrdersSellLimit++ ;  break;
           }
		}
	}
	//     - ,   + 
	// ( _ExpertOrdersTotal = 0,     1)
	temp_value = MathMax( _ExpertOrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );
	
	_OrderTicket[_ExpertOrdersTotal] = 99999999;//       
   ArraySort(_OrderTicket);  //   ...
//------------------------------------------------------------------------------------------------------------------------
	for (   z = 0;  z < _ExpertOrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( _OrderTicket[z], SELECT_BY_TICKET ) )
		{
			_GetLastError = GetLastError();
			Print("OrderSelect( ", _OrderTicket[z], ", SELECT_BY_TICKET ) - Error #", _GetLastError );
			continue;
		}
 			//   
 			_OrderType			[z] = OrderType();
			_OrderLots			[z] = NormalizeDouble( OrderLots(), 2 );
			_OrderOpenPrice	[z] = NormalizeDouble( OrderOpenPrice(), Digits );
			_OrderStopLoss		[z] = NormalizeDouble( OrderStopLoss(), Digits );
			_OrderTakeProfit	[z] = NormalizeDouble( OrderTakeProfit(), Digits );
			_OrderOpenTime		[z] = OrderOpenTime();
			_OrderProfit		[z] = NormalizeDouble( OrderProfit(), 2 );
			_OrderSwap			[z] = NormalizeDouble( OrderSwap(), 2 );
			_OrderCommission	[z] = NormalizeDouble( OrderCommission(), 2 );
			_OrderComment		[z] = OrderComment();
			_OrderExpiration	[z] = OrderExpiration();
	      _OrderMagicNumber [z] = OrderMagicNumber();
			
  	}
//------------------------------------------------------------------------------------------------------------------------ 
return;	
}
//------------------------------------------------------------------------------------------------------------------------   

//http://www.mql4.com/ru/users/bstone -  -  ,   (..)
//+------------------------------------------------------------------+
//| helper functions   -                                         
//+------------------------------------------------------------------+

int sign( double v )
{
    if( v < 0 ) return( -1 );
    return( 1 );
}

//+------------------------------------------------------------------+
double iif( bool condition, double ifTrue, double ifFalse )
{
    if( condition ) return( ifTrue );
    
    return( ifFalse );
}

//+------------------------------------------------------------------+
string iifStr( bool condition, string ifTrue, string ifFalse )
{
    if( condition ) return( ifTrue );

    return( ifFalse );
}

//+------------------------------------------------------------------+
int orderDirection()
{
    return( 1 - 2 * ( OrderType() % 2 ) );
}
//------------------------------------------------------------------------------------------------------------------------   
 